"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var index_exports = {};
__export(index_exports, {
  createTRPCVueQueryClient: () => createTRPCVueQueryClient
});
module.exports = __toCommonJS(index_exports);
var import_vue_query = require("@tanstack/vue-query");
var import_client = require("@trpc/client");
var import_server = require("@trpc/server");
var import_unstable_core_do_not_import = require("@trpc/server/unstable-core-do-not-import");
var import_core = require("@vueuse/core");
var import_vue = require("vue");
function getQueryKey(path, input, type) {
  const splitPath = path.flatMap((part) => part.split("."));
  if (input === void 0 && !type) {
    return splitPath.length > 0 ? [splitPath] : [];
  }
  return [
    splitPath,
    {
      ...input !== void 0 && input !== import_vue_query.skipToken && { input },
      ...type && { type }
    }
  ];
}
function maybeToRefs(obj) {
  return (0, import_vue.isReactive)(obj) ? (0, import_core.toRefs)(obj) : (0, import_core.toRefs)((0, import_core.toRef)(obj));
}
function createVueQueryProxyDecoration(name, trpc, queryClient) {
  return (0, import_unstable_core_do_not_import.createRecursiveProxy)(({ args, path: _path }) => {
    const path = [name, ..._path];
    const prop = path.pop();
    const joinedPath = path.join(".");
    const [firstArg, ...rest] = args;
    const opts = rest[0] || {};
    if (prop === "_def") {
      return { path };
    }
    if (prop === "query") {
      return trpc.query(joinedPath, firstArg, opts);
    }
    function createQuery(_input, { trpcOptions, queryOptions }, { type = "query" } = {}) {
      const queryFn = (0, import_vue.computed)(
        () => (0, import_vue.toValue)(_input) === import_vue_query.skipToken ? import_vue_query.skipToken : async ({ signal }) => {
          const input = (0, import_vue.toValue)(_input);
          const output = await trpc.query(joinedPath, input, {
            signal,
            ...trpcOptions
          });
          if (type === "queries") return { output, input };
          return output;
        }
      );
      return (0, import_vue_query.queryOptions)({
        queryKey: (0, import_vue.computed)(() => getQueryKey(path, (0, import_vue.toValue)(_input), type)),
        queryFn,
        ...maybeToRefs(queryOptions)
      });
    }
    if (prop === "useQuery") {
      const { trpc: trpcOptions, ...queryOptions } = opts;
      const input = firstArg;
      return (0, import_vue_query.useQuery)(createQuery(input, { trpcOptions, queryOptions }));
    }
    if (prop === "useQueries") {
      const { trpc: trpcOptions, combine, shallow, ...queryOptions } = opts;
      const inputs = firstArg;
      return (0, import_vue_query.useQueries)({
        queries: (0, import_vue.computed)(
          () => (0, import_vue.toValue)(inputs).map(
            (i) => createQuery(i, { trpcOptions, queryOptions }, { type: "queries" })
          )
        ),
        combine,
        ...maybeToRefs({ shallow })
      });
    }
    if (prop === "invalidate") {
      return queryClient.invalidateQueries({
        queryKey: getQueryKey(path, (0, import_vue.toValue)(firstArg), "query")
      });
    }
    if (prop === "setQueryData") {
      return queryClient.setQueryData(getQueryKey(path, (0, import_vue.toValue)(opts), "query"), firstArg);
    }
    if (prop === "key") {
      return getQueryKey(path, (0, import_vue.toValue)(firstArg), "query");
    }
    if (prop === "mutate") {
      return trpc.mutation(joinedPath, firstArg, opts);
    }
    if (prop === "useMutation") {
      const { trpc: trpcOptions, ...mutationOptions } = firstArg || {};
      return (0, import_vue_query.useMutation)({
        mutationKey: (0, import_vue.computed)(() => getQueryKey(path, void 0)),
        mutationFn: async (payload) => trpc.mutation(joinedPath, payload, {
          ...trpcOptions
        }),
        ...maybeToRefs(mutationOptions)
      });
    }
    if (prop === "subscribe") {
      return trpc.subscription(joinedPath, firstArg, opts);
    }
    if (prop === "useSubscription") {
      const inputData = (0, import_core.toRef)(firstArg);
      const subscription = (0, import_vue.shallowRef)();
      (0, import_vue.watch)(
        inputData,
        () => {
          if (inputData.value === import_vue_query.skipToken) return;
          subscription.value?.unsubscribe();
          subscription.value = trpc.subscription(joinedPath, inputData.value, {
            ...opts
          });
        },
        { immediate: true }
      );
      (0, import_vue.onScopeDispose)(() => {
        subscription.value?.unsubscribe();
      }, true);
      return subscription.value;
    }
    if (prop === "useInfiniteQuery") {
      const { trpc: trpcOptions, ...queryOptions } = opts;
      return (0, import_vue_query.useInfiniteQuery)({
        queryKey: (0, import_vue.computed)(() => getQueryKey(path, (0, import_vue.toValue)(firstArg), "infinite")),
        queryFn: async ({ queryKey, pageParam, signal }) => trpc.query(
          joinedPath,
          {
            ...queryKey[1]?.input,
            cursor: pageParam
          },
          {
            signal,
            ...trpcOptions
          }
        ),
        ...maybeToRefs(queryOptions)
      });
    }
    throw new Error(`Method '.${prop}()' not supported`);
  });
}
function createTRPCVueQueryClient({
  trpc,
  queryClient
}) {
  const client = (0, import_client.createTRPCUntypedClient)(trpc);
  const decoratedClient = (0, import_server.createTRPCFlatProxy)((key) => {
    return createVueQueryProxyDecoration(key.toString(), client, queryClient);
  });
  return decoratedClient;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createTRPCVueQueryClient
});
